#include <iostream>
#include <string>
#include <vector>

using namespace std;

enum Ciasto { Cienkie, Grube };
enum Sos { Pomidorowy, Czosnkowy, Ostry };
enum Skadnik { SerMozarella, Szynka, Salami, Cebula, Pieczarki };

//produkt
class Pizza
{
public:
	string Nazwa;
	Ciasto RodzajCiasta;
	Sos RodzajSosu;
	vector<Skadnik> Skadniki;

	Pizza()
	{
	}

	void Drukuj()
	{
		cout << this->Nazwa << endl << "Ciasto: " << this->RodzajCiasta << endl << "Sod: " << this->RodzajSosu << endl;
		cout << "Skadniki:" << endl;
		for(vector<Skadnik>::const_iterator i = Skadniki.begin(); i!=Skadniki.end(); i++)
		{
			cout << "\t" << *i << endl;
		}
	}
};

//abstrakcyjny budowniczy
class PizzaBuilder
{
protected:
	Pizza* pizza;

	PizzaBuilder()
	{
		pizza = new Pizza();
	}

public:
	virtual Pizza* GetPizza()
	{
		return pizza;
	}

	virtual void WyrbCiasto() = 0;
	virtual void DoSkadniki() = 0;
	virtual void Piecz() = 0;
	virtual void PolejSosem() = 0;
};

//konkretny budowniczy
class MargaritaBuilder : public PizzaBuilder
{
public:
	MargaritaBuilder()
		:PizzaBuilder()
	{
		pizza->Nazwa = "Margarita";
	}

	void WyrbCiasto()
	{
		this->pizza->RodzajCiasta = Ciasto::Cienkie;
	}

	void Piecz()
	{
		//pieczenie
	}

	void PolejSosem()
	{
		this->pizza->RodzajSosu = Sos::Pomidorowy;
	}

	void DoSkadniki()
	{
		this->pizza->Skadniki.push_back(Skadnik::SerMozarella);
	}
};

//nadzorca
class PizzaDirector
{
public:
	PizzaDirector()
	{
	}

	void StwrzPizz(PizzaBuilder& pb)
	{
		pb.WyrbCiasto();
		pb.DoSkadniki();
		pb.Piecz();
		pb.PolejSosem();
	}
};