#include <iostream>
#include <string>

using namespace std;

//produkt abstrakcyjny
class Samochd
{
public:
	bool Sportowy;
	string Typ;
	float Cena;

	void Drukuj()
	{
		string s = Sportowy ? "sportowy" : "zwyky";
		cout << "Samochd " << Typ << ", " << s << ", cena: " << Cena << endl;
	}

protected:
	Samochd(string typ, float cena, bool sportowy)
	{
		Typ = typ;
		Cena = cena;
		Sportowy = sportowy;
	}
};

class SamochdElektryczny : public Samochd
{
public:
	SamochdElektryczny()
		:Samochd("elektryczny", 29.99f, true)
	{
	}
};

class SamochdDrewniany : public Samochd
{
public:
	SamochdDrewniany()
		:Samochd("drewniany", 14.99f, false)
	{
	}
};

//fabryka abstrajcyjna
class FabrykaZabawek
{
public:
	virtual Samochd* StwrzSamochd() = 0;
	//+ inne zabawki, jeeli mamy
};

class FabrykaZabawekElektrycznych : public FabrykaZabawek
{
public:
	Samochd* StwrzSamochd()
	{
		return new SamochdElektryczny();
	}
};

class FabrykaZabawekDrewnianych : public FabrykaZabawek
{
public:
	Samochd* StwrzSamochd()
	{
		return new SamochdDrewniany();
	}
};
