#include <iostream>
#include <string>
#include <vector>

using namespace std;

enum Ciasto { Cienkie, Grube };
enum Sos { Pomidorowy, Czosnkowy, Ostry };
enum Skadnik { SerMozarella, Szynka, Salami, Cebula, Pieczarki };

//produkt
class Pizza
{
public:
	string Nazwa;
	Ciasto RodzajCiasta;
	Sos RodzajSosu;
	vector<Skadnik> Skadniki;

	Pizza()
	{
	}

	void Drukuj()
	{
		cout << this->Nazwa << endl << "Ciasto: " << this->RodzajCiasta << endl << "Sod: " << this->RodzajSosu << endl;
		cout << "Skadniki:" << endl;
		for(vector<Skadnik>::const_iterator i = Skadniki.begin(); i!=Skadniki.end(); i++)
		{
			cout << "\t" << *i << endl;
		}
	}
};

class Margarita : public Pizza
{
public:
	Margarita()
	{
		this->Nazwa = "Margarita";
		this->RodzajCiasta = Ciasto::Cienkie;
		this->RodzajSosu = Sos::Pomidorowy;
		this->Skadniki.push_back(Skadnik::SerMozarella);
	}
};

//abstrakcyjny budowniczy
class PizzaMaker
{
protected:
	Pizza* pizza;

	PizzaMaker()
	{
		pizza = new Pizza();
	}

public:
	virtual Pizza* GetPizza()
	{
		return pizza;
	}

	virtual void PrzygotujPizz() = 0;
};

//konkretny budowniczy
class MargaritaMaker : public PizzaMaker
{
public:
	MargaritaMaker()
		:PizzaMaker()
	{		
	}

	void PrzygotujPizz()
	{
		this->pizza = new Margarita();
	}
};
